minor improvements
[distro-setup] / brc
1 #!/bin/bash
2 # Copyright (C) 2019 Ian Kelling
3 # SPDX-License-Identifier: AGPL-3.0-or-later
4 # this gets sourced. shebang is just for file mode detection
5
6 # Use source ~/.bashrc instead of doing bash -l when running a script
7 # so this can set extdebug and avoid the bash debugger.
8 if [[ -s /a/bin/errhandle/err ]]; then
9 source /a/bin/errhandle/err
10 elif [[ -s $bashrc_dir/err ]]; then
11 # shellcheck source=/a/bin/errhandle/err
12 source $bashrc_dir/err
13 fi
14
15 # In t8, it runs clear_console for login shells by default. I don't want
16 # my console cleared. And linux ttys get cleared without this.
17 if shopt login_shell >/dev/null && [[ -e ~/.bash_logout ]]; then
18 rm ~/.bash_logout
19 fi
20
21 # if [[ -s /usr/share/bash-completion/completions/git ]]; then
22 # source /usr/share/bash-completion/completions/git
23 # fi
24 # if [[ -s /usr/share/bash-completion/completions/gitk ]]; then
25 # source /usr/share/bash-completion/completions/gitk
26 # fi
27
28 # for testing error catching:
29 # t2() {
30 # echo t2
31 # grep sdf sdfd
32 # echo wtf
33 # }
34 # t1() {
35 # echo t1
36 # t2 a b c
37 # }
38
39 # * settings
40
41 CDPATH=.
42
43
44 # remove all aliases. aliases provided by the system tend to get in the way,
45 # for example, error happens if I try to define a function the same name as an alias
46 unalias -a
47
48 # remove gnome keyring warning messages
49 # there is probably a more proper way, but I didnt find any easily on google
50 # now using xfce+xmonad instead of vanilla xmonad, so disabling this
51 #unset GNOME_KEYRING_CONTROL
52
53 # use extra globing features.
54 shopt -s extglob
55 # include .files when globbing, but ignore files name . and ..
56 # setting this also sets dotglob.
57 export GLOBIGNORE="*/.:*/.."
58
59 # Useful info. see man bash.
60 PS4='$LINENO+ '
61
62
63 # broken with bash_completion package. Saw a bug for this once. dont anymore.
64 # still broken in wheezy
65 # still buggered in latest stable from the web, version 2.1
66 # perhaps its fixed in newer git version, which fails to make for me
67 # this note is from 6-2014.
68 # still broken in flidas.
69 #shopt -s nullglob
70
71 # make tab on an empty line do nothing
72 shopt -s no_empty_cmd_completion
73
74 # fix spelling errors for cd, only in interactive shell
75 shopt -s cdspell
76 # append history instead of overwritting it
77 shopt -s histappend
78 # for compatibility, per gentoo/debian bashrc
79 shopt -s checkwinsize
80 # attempt to save multiline single commands as single history entries.
81 shopt -s cmdhist
82 # enable **
83 shopt -s globstar
84
85
86 # inside emacs fixes
87 if [[ $LC_INSIDE_EMACS ]]; then
88 # EMACS is used by bash on startup, but we dont need it anymore.
89 # plus I hit a bug in a makefile which inherited it
90 unset EMACS
91 export LC_INSIDE_EMACS
92 export PAGER=cat
93 export MANPAGER=cat
94 # scp completion does not work, but this doesnt fix it. todo, figure this out
95 #complete -r scp &> /dev/null
96 # todo, remote file completion fails, figure out how to turn it off
97 export NODE_DISABLE_COLORS=1
98 # This gets rid of ugly terminal escape chars in node repl
99 # sometime, Id like to have completion working in emacs shell for node
100 # the offending chars can be found in lib/readline.js,
101 # things that do like:
102 # stream.write('\x1b[' + (x + 1) + 'G');
103 # We can remove them and keep readline, for example by doing this
104 # to start a repl:
105 #!/usr/bin/env nodejs
106 # var readline = require('readline');
107 # readline.cursorTo = function(a,b,c) {};
108 # readline.clearScreenDown = function(a) {};
109 # const repl = require('repl');
110 # var replServer = repl.start('');
111 #
112 # no prompt, or else readline complete seems to be confused, based
113 # on our column being different? node probably needs to send
114 # different kind of escape sequence that is not ugly. Anyways,
115 # completion doesnt work yet even with the ugly prompt, so whatever
116 #
117 export NODE_NO_READLINE=1
118
119 fi
120
121 export SSH_CONFIG_FILE_OVERRIDE=/root/.ssh/confighome
122
123 # emacs has a different default search path than the info command. This
124 # adds the info defaults to emacs, but not the reverse, because I dun
125 # care much about the cli. The search path is only on the cli if you run
126 # "info xxx", or in emacs if you run '(info xxx)', so not that
127 # important, but might as well fix it.
128
129 # info info says this path is what was compiled, and its not documented
130 # anywhere. Through source grepping, i found it in filesys.h of the info
131 # source in trisquel flidas.
132 #
133 # Traling : means for emacs to add its own stuff on to the end.
134
135 export INFOPATH=$PATH:/usr/local/info:/usr/info:/usr/local/lib/info:/usr/lib/info:/usr/local/gnu/info:/usr/local/gnu/lib/info:/usr/gnu/info:/usr/gnu/lib/info:/opt/gnu/info:/usr/share/info:/usr/share/lib/info:/usr/local/share/info:/usr/local/share/lib/info:/usr/gnu/lib/emacs/info:/usr/local/gnu/lib/emacs/info:/usr/local/lib/emacs/info:/usr/local/emacs/info:.:
136
137 # for openwrt system that has no stty, this is easier than
138 # guarding every time i use it.
139 if ! type -p stty >/dev/null; then
140 stty() { :; }
141 fi
142
143
144 if [[ $- == *i* ]]; then
145 # for readline-complete.el
146 if [[ $LC_INSIDE_EMACS ]]; then
147 # all for readline-complete.el
148 stty echo
149 bind 'set horizontal-scroll-mode on'
150 bind 'set print-completions-horizontally on'
151 bind '"\C-i": self-insert'
152 else
153
154 if [[ $KONSOLE_PROFILE_NAME ]]; then
155 TERM=xterm-256color
156 fi
157
158 if [[ $TERM == alacritty && ! -e /usr/share/terminfo/a/alacritty ]]; then
159 # todo: we should try installing the alacritty terminfo if it is not found
160 # https://github.com/alacritty/alacritty/issues/2838
161 TERM=xterm-256color
162 fi
163
164 # copying from the alacritty example above,
165 if [[ $TERM == xterm-kitty ]]; then
166 if [[ ! -e /usr/share/terminfo/x/xterm-kitty ]]; then
167 TERM=xterm-256color
168 else
169 if [[ -e /a/opt/kitty/shell-integration/bash/kitty.bash ]]; then
170 KITTY_SHELL_INTEGRATION=t
171 source /a/opt/kitty/shell-integration/bash/kitty.bash
172 fi
173 fi
174 fi
175
176 # todo: not sure this works in sakura
177 #stty werase undef
178 #bind "\C-w": kill-region
179 # sakura == xterm-256color
180 # konsole == xterm
181 if [[ $TERM != xterm-kitty && $TERM == xterm* ]]; then
182 # control + arrow keys. for other terminals, see http://unix.stackexchange.com/questions/10806/how-to-change-previous-next-word-shortcut-in-bash
183 bind '"\e[1;5C": shell-forward-word' 2>/dev/null
184 bind '"\e[1;5D": shell-backward-word' 2>/dev/null
185 else
186 # make ctrl-backspace work. for konsole, i fixed it through
187 # /home/iank/.local/share/konsole/default.keytab
188 stty werase ^h
189 bind '"\eOc": shell-forward-word'
190 bind '"\eOd": shell-backward-word'
191 fi
192 # i cant remember why i did this, probably to free up some keys to bind
193 # to other things in bash.
194 # other than C-c and C-z, the rest defined by stty -a are, at least in
195 # gnome-terminal, overridden by bash, or disabled by the system
196 stty lnext undef stop undef start undef
197 fi
198
199 fi
200
201 export BC_LINE_LENGTH=0
202
203 # ansible option
204 export PROFILE_TASKS_TASK_OUTPUT_LIMIT=100
205
206 # note, if I use a machine I dont want files readable by all users, set
207 # umask 077 # If fewer than 4 digits are entered, leading zeros are assumed
208
209 # i for insensitive. the rest from
210 # X means dont remove the current screenworth of output upon exit
211 # R means to show colors n things
212 export LESS=RXij12
213 export SYSTEMD_LESS=$LESS
214
215 export NNN_COLORS=2136
216
217 export SL_FILES_DIR=/b/ds/sl/.iank
218 export SL_INFO_DIR=/p/sshinfo
219
220
221 # * include files
222
223 if [[ -s $bashrc_dir/path-add-function ]]; then
224 source $bashrc_dir/path-add-function
225 if [[ $SSH_CLIENT ]]; then
226 # [[ -d /home/iank/.iank/e/e ]] mounts it unnecessarily, so use this.
227 if grep -qF /home/iank/.iank/e/e /etc/auto.iank /etc/exports &>/dev/null; then
228 export EMACSDIR=/home/iank/.iank/e/e
229 fi
230 path-add $bashrc_dir
231 fi
232 fi
233
234 # if someone exported $SOE (stop on error), catch errors.
235 #
236 # Note, on debian this results in the following warning when in ssh,
237 # hich I haven't figured out how to fix. It doesn't happen if we source
238 # after the shell has started
239 #
240 # bash: /usr/share/bashdb/bashdb-main.inc: No such file or directory
241 # bash: warning: cannot start debugger; debugging mode disabled
242 if [[ $SOE ]]; then
243 if [[ -e /a/bin/errhandle/err ]]; then
244 source /a/bin/errhandle/err
245 fi
246 fi
247
248 # based on readme.debian. dunno if this will break on other distros.
249 if [[ -s /usr/share/wcd/wcd-include.sh ]]; then
250 source /usr/share/wcd/wcd-include.sh
251 fi
252
253
254 mysrc() {
255 local path dir file
256 path=$1
257 dir=${path%/*}
258 file=${path##*/}
259 if [[ -s $path ]]; then
260 source $path
261 elif [[ -s $bashrc_dir/$file ]]; then
262 source $bashrc_dir/$file
263 fi
264 }
265
266
267 mysrc /a/bin/small-misc-bash/ll-function
268 mysrc /a/bin/distro-functions/src/package-manager-abstractions
269
270
271 # * functions
272 ccomp() { # copy completion
273 local src=$1
274 local c
275 shift
276 if ! c=$(complete -p $src 2>/dev/null); then
277 _completion_loader $src &>/dev/null ||:
278 c=$(complete -p $src 2>/dev/null) || return 0
279 fi
280 # remove $src( .*|$)
281 c=${c% $src}
282 c=${c%% $src *}
283 eval $c $*
284 }
285
286
287 ..() { c ..; }
288 ...() { c ../..; }
289 ....() { c ../../..; }
290 .....() { c ../../../..; }
291 ......() { c ../../../../..; }
292
293 chere() {
294 local f path
295 for f; do
296 path=$(readlink -e "$f")
297 echo "cat >$path <<'EOF'"
298 cat "$f"
299 echo EOF
300 done
301 }
302
303
304 # file cut copy and paste, like the text buffers :)
305 # I havnt tested these.
306 _fbufferinit() { # internal use
307 ! [[ $my_f_tempdir ]] && my_f_tempdir=$(mktemp -d)
308 rm -rf "${my_f_tempdir:?}"/*
309 }
310 fcp() { # file cp
311 _fbufferinit
312 cp "$@" "$my_f_tempdir"/
313 }
314 fct() { # file cut
315 _fbufferinit
316 mv "$@" "$my_f_tempdir"/
317 }
318 fpst() { # file paste
319 [[ $2 ]] && { echo too many arguments; return 1; }
320 target=${1:-.}
321 cp "$my_f_tempdir"/* "$target"
322 }
323
324 _khfix_common() {
325 local host ip port
326 read -r host ip port < <(timeout -s 9 2 ssh -oBatchMode=yes -oControlMaster=no -oControlPath=/ -v $1 |& sed -rn "s/debug1: Connecting to ([^ ]+) \[([^\]*)] port ([0-9]+).*/\1 \2 \3/p" ||: )
327 if [[ ! $ip ]]; then
328 echo "khfix: ssh failed"
329 return 1
330 fi
331 if [[ $port != 22 ]]; then
332 ip_entry="[$ip]:$port"
333 host_entry="[$host]:$port"
334 else
335 ip_entry=$ip
336 host_entry=$host
337 fi
338 if [[ $host != $ip ]]; then
339 m ssh-keygen -R "$host_entry" -f $(readlink -f ~/.ssh/known_hosts)
340 ll ~/.ssh/known_hosts
341 fi
342 m ssh-keygen -R "$ip_entry" -f $(readlink -f ~/.ssh/known_hosts)
343 ll ~/.ssh/known_hosts
344 rootsshsync
345 }
346 khfix() { # known hosts fix
347 _khfix_common "$@" || return 1
348 ssh $1 :
349 }
350 khcopy() {
351 _khfix_common "$@"
352 ssh-copy-id $1
353 }
354
355 a() {
356 local x
357 x=$(readlink -nf "${1:-$PWD}")
358 # yes, its kinda dumb that xclip/xsel cant do this in one invocation
359 echo -n "$x" | xclip -selection clipboard
360 echo -n "$x" | xclip
361 }
362
363 # a1 = awk {print $1}
364 for field in {1..20}; do
365 eval a$field"() { awk '{print \$$field}'; }"
366 done
367 # h1 = head -n1
368 for num in {1..9}; do
369 eval h$num"() { head -n$num; }"
370 done
371
372
373 b() {
374 # backwards
375 c -
376 }
377
378
379 # c. better cd
380 if type -p wcd &>/dev/null; then
381 if [[ $LC_INSIDE_EMACS ]]; then
382 c() { wcd -c -z 50 -o "$@"; }
383 else
384 # lets see what the fancy terminal does from time to time
385 c() { wcd -c -z 50 "$@"; }
386 fi
387 else
388 c() { cd "$@"; }
389 fi
390 ccomp cd c
391
392 c4() { c /var/log/exim4; }
393
394 caa() { git commit --amend --no-edit -a; }
395
396 cf() {
397 for f; do
398 hr
399 echo "$f"
400 hr
401 cat "$f"
402 done
403 }
404 caf() {
405 # shellcheck disable=SC2033
406 find -L "$@" -type f -not \( -name .svn -prune -o -name .git -prune \
407 -o -name .hg -prune -o -name .editor-backups -prune \
408 -o -name .undo-tree-history -prune \) \
409 -exec bash -c '. ~/.bashrc; hr; echo "$1"; hr; cat "$1"' _ {} \; 2>/dev/null
410
411 }
412 ccomp cat cf caf
413
414 calc() { echo "scale=3; $*" | bc -l; }
415 # no having to type quotes, but also no command history:
416 clc() {
417 local x
418 read -r x
419 echo "scale=3; $x" | bc -l
420 }
421
422 cam() {
423 git commit -am "$*"
424 }
425
426 ccat () { # config cat. see a config without extra lines.
427 sed -r '/^[[:space:]]*([;#]|--|\/\/|$)/d' "$@"
428 }
429 ccomp grep ccat
430
431 chrbind() {
432 local d
433 # dev/pts needed for pacman signature check
434 for d in dev proc sys dev/pts; do
435 [[ -d $d ]]
436 if ! mountpoint $d &>/dev/null; then
437 s mount -o bind /$d $d
438 fi
439 done
440 }
441
442
443 _cdiff-prep() {
444 # join options which are continued to multiples lines onto one line
445 local first=true
446 while IFS= read -r line; do
447 # remove leading spaces/tabs. assumes extglob
448 if [[ $line == "[ ]*" ]]; then
449 line="${line##+( )}"
450 fi
451 if $first; then
452 pastline="$line"
453 first=false
454 elif [[ $line == *=* ]]; then
455 echo "$pastline" >> "$2"
456 pastline="$line"
457 else
458 pastline="$pastline $line"
459 fi
460 done < <(grep -vE '^([ \t]*#|^[ \t]*$)' "$1")
461 echo "$pastline" >> "$2"
462 }
463
464 cdiff() {
465 # diff config files,
466 # setup for format of postfix, eg:
467 # option = stuff[,]
468 # [more stuff]
469 local pastline unified f1 f2
470 unified="$(mktemp)"
471 f1="$(mktemp)"
472 f2="$(mktemp)"
473 _cdiff-prep "$1" "$f1"
474 _cdiff-prep "$2" "$f2"
475 cat "$f1" "$f2" | grep -Po '^[^=]+=' | sort | uniq > "$unified"
476 while IFS= read -r line; do
477 # the default bright red / blue doesnt work in emacs shell
478 dwdiff -cblue,red -A best -d " ," <(grep "^$line" "$f1" || echo ) <(grep "^$line" "$f2" || echo ) | colordiff
479 done < "$unified"
480 }
481
482
483 cat-new-files() {
484 local start=$SECONDS
485 local dir="$1"
486 inotifywait -m "$dir" -e create -e moved_to |
487 # shellcheck disable=SC2030
488 while read -r filedir _ file; do
489 cat "$filedir$file"
490 hr
491 calc $((SECONDS - start)) / 60
492 sleep 5
493 done
494
495 }
496
497 # shellcheck disable=SC2032
498 chown() {
499 # makes it so chown -R symlink affects the symlink and its target.
500 if [[ $1 == -R ]]; then
501 shift
502 command chown -h "$@"
503 command chown -R "$@"
504 else
505 command chown "$@"
506 fi
507 }
508
509 cim() {
510 git commit -m "$*"
511 }
512
513 cl() {
514 # choose recent directory. cl = cd list
515 c =
516 }
517
518 d() { builtin bg "$@"; }
519 ccomp bg d
520
521 dc() {
522 diff --strip-trailing-cr -w "$@" # diff content
523 }
524 ccomp diff dc
525
526 despace() {
527 local x y
528 for x in "$@"; do
529 y="${x// /_}"
530 safe_rename "$x" "$y"
531 done
532 }
533
534 dig() {
535 command dig +nostats +nocmd "$@"
536 }
537 # Output with sections sorted, and removal of query id, so 2 dig outputs can be diffed.
538 digsort() {
539 local sec
540 sec=
541 dig +nordflag "$@" | sed -r 's/^(;; ->>HEADER<<-.*), id: .*/\1/' | while read -r l; do
542 if [[ $l == [^\;]* ]]; then
543 sec+="$l"$'\n'
544 else
545 if [[ $sec ]]; then
546 printf "%s" "$sec" | sort
547 sec=
548 fi
549 printf "%s\n" "$l"
550 fi
551 done
552 }
553 ccomp dig digsort
554 # compare digs to the 2 servers
555 # usage: digdiff @server1 @server2 DIG_ARGS
556 # note: only the soa master nameserver will respond with
557 # ra "recursive answer" flag. That difference is meaningless afaik.
558 digdiff() {
559 local s1 s2
560 s1=$1
561 shift
562 s2=$1
563 shift
564 digsort $s1 "$@" | tee /tmp/digdiff
565 diff -u /tmp/digdiff <(digsort $s2 "$@")
566 }
567
568 dt() {
569 date "+%A, %B %d, %r" "$@"
570 }
571 ccomp date dt
572
573 dus() { # du, sorted, default arg of
574 du -sh ${@:-*} | sort -h
575 }
576 ccomp du dus
577
578
579 e() { echo "$@"; }
580
581 # echo args
582 ea() {
583 if (( ! $# )); then
584 echo no args
585 fi
586 for arg; do
587 printf "%qEOL\n" "${arg}"
588 printf "%s" "${arg}" |& hexdump -C
589 done
590 }
591 # echo vars. print var including escapes, etc
592 ev() {
593 if (( ! $# )); then
594 echo no args
595 fi
596 for arg; do
597 if [[ -v $arg ]]; then
598 printf "%qEOL\n" "${!arg}"
599 printf "%s" "${!arg}" |& hexdump -C
600 else
601 echo arg $arg is unset
602 fi
603 done
604 }
605
606 ediff() {
607 [[ ${#@} == 2 ]] || { echo "error: ediff requires 2 arguments"; return 1; }
608 emacs --eval "(ediff-files \"$1\" \"$2\")"
609 }
610
611 # mail related
612 etail() {
613 tail -F /var/log/exim4/mainlog -n 200 "$@"
614 }
615 ccomp tail etail
616
617 # print exim old pids
618 eoldpids() {
619 local configtime pid piduptime now daemonpid
620 printf -v now '%(%s)T' -1
621 configtime=$(stat -c%Y /var/lib/exim4/config.autogenerated)
622 if [[ -s /run/exim4/exim.pid ]]; then
623 daemonpid=$(cat /run/exim4/exim.pid)
624 fi
625 for pid in $(pgrep -f '^/usr/sbin/exim4( |$)'); do
626 # the daemonpid gets reexeced on HUP (service reloads), keeping its same old timestamp
627 if [[ $pid == $daemonpid ]]; then
628 continue
629 fi
630 piduptime=$(awk -v ticks="$(getconf CLK_TCK)" 'NR==1 { now=$1; next } END { printf "%9.0f\n", now - ($20/ticks) }' /proc/uptime RS=')' /proc/$pid/stat) ||: # sometimes pids disappear pretty fast
631 if (( configtime > now - piduptime )); then
632 echo $pid
633 fi
634 done
635 }
636
637 # exim tail but only watch lines from new pids
638 etailnew() {
639 local pid oldpids
640 for pid in $(eoldpids); do
641 oldpids+="$pid|"
642 done
643 if [[ $oldpids ]]; then
644 etail | awk '$3 !~ /^\[('"${oldpids%|}"')\]$/'
645 else
646 etail
647 fi
648 }
649 # exim watch as old pids go away
650 ewatchold() {
651 local configtime pid piduptime now
652 local -i count
653 local -a oldpids
654 count=0
655 while true; do
656 oldpids=($(eoldpids))
657 if (( ! ${#oldpids[@]} )); then
658 return
659 fi
660 # print the date every 20 iterations
661 if (( ! count % 20 )); then
662 date
663 fi
664 count+=1
665 ps -f -p "${oldpids[*]}"
666 sleep 1
667 done
668 }
669
670 eless() {
671 less /var/log/exim4/mainlog
672 }
673 ccomp less eless
674 eqcat() {
675 exiqgrep -i -o 60 | while read -r i; do
676 hlm exim -Mvc $i
677 echo
678 hlm exigrep $i /var/log/exim4/mainlog | cat ||:
679 done
680 }
681 eqrmf() {
682 exiqgrep -i | xargs exim -Mrm
683 }
684
685 econfdevnew() {
686 rm -rf /tmp/edev
687 mkdir -p /tmp/edev/etc
688 cp -ra /etc/exim4 /tmp/edev/etc
689 cp -ra /etc/alias* /tmp/edev/etc
690 find /tmp/edev/etc/exim4 -type f -execdir sed -i "s,/etc/,/tmp/edev/etc/,g" '{}' +
691 econfdev
692 }
693 econfdev() {
694 update-exim4.conf -d /tmp/edev/etc/exim4 -o /tmp/edev/e.conf
695 }
696
697
698
699 # shellcheck disable=SC2032
700 f() {
701 # cd forward
702 c +
703 }
704
705 fa() {
706 # find array. make an array of file names found by find into $x
707 # argument: find arguments
708 # return: find results in an array $x
709 while read -rd ''; do
710 x+=("$REPLY");
711 done < <(find "$@" -print0);
712 }
713
714 faf() { # find all files. use -L to follow symlinks
715 find "$@" -not \( -name .svn -prune -o -name .git -prune \
716 -o -name .hg -prune -o -name .editor-backups -prune \
717 -o -name .undo-tree-history -prune \) -type f 2>/dev/null
718 }
719
720 # todo: id like to do maybe a daily or hourly cronjob to
721 # check that my history file size is increasing. Ive had it
722 # inexplicably truncated in the past.
723 histrm() {
724 history -n
725 history | awk -v IGNORECASE=1 '{ a=$1; sub(/^( *[^ ]+){4} */, "") }; /'"$*"'/'
726 read -p "press anything but contrl-c to delete"
727 for entry in $(history | awk -v IGNORECASE=1 '{ a=$1; sub(/^( *[^ ]+){4} */, "") }; /'"$*"'/ { print a }' | tac); do
728 history -d $entry
729 done
730 history -w
731 }
732
733 # mail related
734 frozen() {
735 rm -rf /tmp/frozen
736 sudo mailq |gr frozen|awk '{print $3}' | while read -r id; do
737 sudo exim -Mvl $id
738 echo
739 sudo exim -Mvh $id
740 echo
741 sudo exim -Mvb $id
742 echo -e '\n\n##############################\n'
743 done | tee -a /tmp/frozen
744 }
745 frozenrm() {
746 local ids=()
747 while read -r line; do
748 printf '%s\n' "$line"
749 ids+=($(printf '%s\n' "$line" |gr frozen|awk '{print $3}'))
750 done < <(s mailq)
751 echo "sleeping for 2 in case you change your mind"
752 sleep 2
753 sudo exim -Mrm "${ids[@]}"
754 }
755
756 funce() {
757 # like -e for functions. returns on error.
758 # at the end of the function, disable with:
759 # trap ERR
760 trap 'echo "${BASH_COMMAND:+BASH_COMMAND=\"$BASH_COMMAND\" }
761 ${FUNCNAME:+FUNCNAME=\"$FUNCNAME\" }${LINENO:+LINENO=\"$LINENO\" }\$?=$?"
762 trap ERR
763 return' ERR
764 }
765
766 getdir () {
767 local help="Usage: getdir [--help] PATH
768 Output the directory of PATH, or just PATH if it is a directory."
769 if [[ $1 == --help ]]; then
770 echo "$help"
771 return 0
772 fi
773 if [[ $# -ne 1 ]]; then
774 echo "getdir error: expected 1 argument, got $#"
775 return 1
776 fi
777 if [[ -d $1 ]]; then
778 echo "$1"
779 else
780 local dir
781 dir="$(dirname "$1")"
782 if [[ -d $dir ]]; then
783 echo "$dir"
784 else
785 echo "getdir error: directory does not exist"
786 return 1
787 fi
788 fi
789 }
790
791 git_empty_branch() { # start an empty git branch. carefull, it deletes untracked files.
792 [[ $# == 1 ]] || { echo 'need a branch name!'; return 1;}
793 local root
794 root=$(gitroot) || return 1 # function to set gitroot
795 builtin cd "$root"
796 git symbolic-ref HEAD refs/heads/$1
797 rm .git/index
798 git clean -fdx
799 }
800
801 # shellcheck disable=SC2120
802 gitroot() {
803 local help="Usage: gitroot [--help]
804 Print the full path to the root of the current git repo
805
806 Handles being within a .git directory, unlike git rev-parse --show-toplevel,
807 and works in older versions of git which did not have that."
808 if [[ $1 == --help ]]; then
809 echo "$help"
810 return
811 fi
812 local p
813 p=$(git rev-parse --git-dir) || { echo "error: not in a git repo" ; return 1; }
814 [[ $p != /* ]] && p=$PWD
815 echo "${p%%/.git}"
816 }
817
818 g() {
819
820 # todo: patch emacs so it will look elsewhere. this is kinda sad:
821 # https://emacs.stackexchange.com/questions/4253/how-to-start-emacs-with-a-custom-user-emacs-directory
822
823 local args gdb=false
824
825 if [[ $EMACSDIR ]]; then
826 path-add "$EMACSDIR/lib-src" "$EMACSDIR/src"
827 fi
828
829 if [[ $DISPLAY ]]; then
830 args=-n
831 fi
832
833 if (( $# == 0 )); then
834 args+=" -c"
835 fi
836 # duplicate -c, but oh well
837 if ! pgrep -u $EUID emacsclient; then
838 if (( $# == 0 )) && type -p gdb &>/dev/null; then
839 gdb=true
840 else
841 args+=" -c"
842 fi
843 fi
844 if [[ $EMACSDIR ]]; then
845 # Alter the path here, otherwise the nfs mount gets triggered on the
846 # first path lookup when emacs is not being used.
847 PATH="$EMACSDIR/lib-src:$EMACSDIR/src:$PATH" EHOME=$HOME HOME=$EMACSDIR m emacsclient -a "" $args "$@"
848 else
849 if $gdb; then
850 # due to a bug, we cant debug from the start unless we get a new gdb
851 # https://sourceware.org/bugzilla/show_bug.cgi?id=24454
852 # m gdb -ex="set follow-fork-mode child" -ex=r -ex=quit --args emacs --daemon
853 m emacsclient -a "" $args "$@"
854 sleep 1
855 cd /a/opt/emacs-$(distro-name)$(distro-num)
856 s gdb -p $(pgrep -f 'emacs --daemon') -ex c
857 cd -
858 else
859 m emacsclient -a "" $args "$@"
860 fi
861 fi
862 }
863
864 # force terminal version
865 gn() {
866 g -n "$@"
867 }
868
869 gmacs() {
870 # quit will prompt if the program crashes.
871 gdb -ex=r -ex=quit --args emacs "$@"; r;
872 }
873
874 gdkill() {
875 # kill the emacs daemon
876 pk1 emacs --daemon
877 }
878
879 gr() {
880 grep -iIP --color=auto "$@" || return $?
881 }
882 grr() { # grep recursive
883 # Don't return 1 on nonmatch because this is meant to be
884 # interactive, not in a conditional.
885 if [[ ${#@} == 1 ]]; then
886 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -riIP --color=auto "$@" . || [[ $? == 1 ]]
887 else
888 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -riIP --color=auto "$@" || [[ $? == 1 ]]
889 fi
890 }
891 ccomp grep gr grr
892
893 rg() { grr "$@"; }
894 ccomp grep rg
895
896 hr() { # horizontal row. used to break up output
897 printf "$(tput setaf 5 2>/dev/null ||:)â–ˆ$(tput sgr0 2>/dev/null||:)%.0s" $(eval echo "{1..${COLUMNS:-60}}")
898 echo
899 }
900 # highlight
901 hl() {
902 local col input_len=0
903 for arg; do
904 input_len=$((input_len + 1 + ${#arg}))
905 done
906 col=$((60 - input_len))
907 printf "\e[1;97;41m%s" "$*"
908 if (( col > 0 )); then
909 printf "\e[1;97;41m \e[0m%.0s" $(eval echo "{1..${col}}")
910 fi
911 echo
912 }
913 hlm() { hl "$*"; "$@"; }
914
915 hrcat() { local f; for f; do [[ -f $f ]] || continue; hr; echo "$f"; cat "$f"; done }
916
917
918 # get latest hub and run it
919 # main command to use:
920 # hub pull-request --no-edit
921 # --no-edit means to use the first commit\'s message as the pull request message.
922 # If that fails, try doing
923 # hub pull-request --no-edit -b UPSTREAM_OWNER:branch
924 # where branch is usually master. it does the pr against your current branch.
925 #
926 # On first use, you input username/pass and it gets an oath token so you dont have to repeat
927 # it\'s at ~/.config/hub
928 hub() {
929 local up uptar updir p
930 p=/github/hub/releases/
931 up=https://github.com/$(curl -s https://github.com$p| grep -o $p'download/[^/]*/hub-linux-amd64[^"]*' | head -n1)
932 uptar=${up##*/}
933 updir=${uptar%.tgz}
934 if [[ ! -e /a/opt/$updir ]]; then
935 rm -rf /a/opt/hub-linux-amd64*
936 wget -P /a/opt $up
937 tar -C /a/opt -zxf /a/opt/$uptar
938 rm -f /a/opt/$uptar
939 fi
940 if ! which hub &>/dev/null; then
941 sudo /a/opt/$updir/install
942 fi
943
944 # save token across computers
945 if [[ ! -L ~/.config/hub ]]; then
946 if [[ -e ~/.config/hub ]]; then
947 mv ~/.config/hub /p/c/subdir_files/.config/
948 fi
949 if [[ -e /p/c/subdir_files/.config/hub ]]; then
950 conflink
951 fi
952 fi
953 command hub "$@"
954 }
955
956 i() { git "$@"; }
957 ccomp git i
958
959 ic() {
960 # fast commit all
961 git commit -am "$*"
962 }
963
964
965 ifn() {
966 # insensitive find
967 find -L . -not \( -name .svn -prune -o -name .git -prune \
968 -o -name .hg -prune -o -name .editor-backups -prune \
969 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
970 }
971
972 ifd() {
973 # insensitive find directory
974 find -L . -type d -not \( -name .svn -prune -o -name .git -prune \
975 -o -name .hg -prune -o -name .editor-backups -prune \
976 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
977 }
978
979
980 ipdrop() {
981 sudo iptables -A INPUT -s $1 -j DROP
982 }
983
984
985 istext() {
986 grep -Il "" "$@" &>/dev/null
987 }
988
989 jtail() {
990 journalctl -n 10000 -f "$@"
991 }
992 jr() { journalctl "$@" ; }
993 jrf() { journalctl -f "$@" ; }
994 jru() {
995 journalctl -u exim4 _SYSTEMD_INVOCATION_ID=$(systemctl show -p InvocationID --value $1)
996 }
997
998 l() {
999 if [[ $PWD == /[iap] ]]; then
1000 command ls -A --color=auto -I lost+found "$@"
1001 else
1002 command ls -A --color=auto "$@"
1003 fi
1004 }
1005
1006 lcn() { locate -i "*$**"; }
1007
1008 lg() { LC_COLLATE=C.UTF-8 ll --group-directories-first "$@"; }
1009
1010 lt() { ll -tr "$@"; }
1011
1012 lld() { ll -d "$@"; }
1013
1014 ccomp ls l lg lt lld ll
1015
1016 # low recursively
1017 lowr() {
1018 local f dirs i a
1019 local -a all
1020 for dirs in false true; do
1021 for f; do
1022 if [[ -d $f ]]; then
1023 all=("$f"/**)
1024 # reverse the order to rename the nested dirs first.
1025 # note: 0 element is the dir itself
1026 for ((i=${#all[@]}-1; i>=1; i--)); do
1027 a="${all[i]}"
1028 if $dirs && [[ -d $a ]]; then
1029 # e dirs low "$a" # debug
1030 low "$a"
1031 elif ! $dirs && [[ ! -d $a && -e $a ]]; then
1032 # debug
1033 # e not dirs low "$a" # debug
1034 low "$a"
1035 fi
1036 done
1037 fi
1038 # just rename all the top level args on the second pass
1039 if $dirs; then
1040 # e final dirs low "$f" # debug
1041 low "$f"
1042 fi
1043 done
1044 done
1045 }
1046
1047 low() { # make filenames lowercase, remove bad chars
1048 local arg new dir f
1049 for arg; do
1050 arg="${arg%%+(/)}" # remove trailing slashes. assumes we have extglob on.
1051 dir="${arg%/*}"
1052 if (( ${#dir} == ${#arg} )); then
1053 dir=.
1054 fi
1055 f="${arg##*/}"
1056 new="${f,,}" # downcase
1057 new="${new//[^[:alnum:]._-]/_}" # sub bad chars
1058 new="${new#"${new%%[[:alnum:]]*}"}" # remove leading/trailing non-alnum
1059 new="${new%"${new##*[[:alnum:]]}"}"
1060 # remove bad underscores, like __ and _._
1061 new=$(echo $new | sed -r 's/__+/_/g;s/_+([.-])|([.-])_+/\1/g')
1062 safe_rename "$dir/$f" "$dir/$new" || return 1
1063 done
1064 return 0
1065 }
1066
1067 lower() { # make first letter of filenames lowercase.
1068 local x
1069 for x in "$@"; do
1070 if [[ ${x::1} == [A-Z] ]]; then
1071 y=$(tr '[:upper:]' '[:lower:]' <<<"${x::1}")"${x:1}"
1072 safe_rename "$x" "$y" || return 1
1073 fi
1074 done
1075 }
1076
1077
1078 k() { # history search
1079 grep -iP --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | tail -n 80 || [[ $? == 1 ]];
1080 }
1081 ks() { # history search
1082 grep -P --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | uniq || [[ $? == 1 ]];
1083 }
1084 ccomp grep k ks
1085
1086
1087 make-targets() {
1088 # show make targets, via http://stackoverflow.com/questions/3063507/list-goals-targets-in-gnu-make
1089 make -qp | awk -F':' '/^[a-zA-Z0-9][^$#\/\t=]*:([^=]|$)/ {split($1,A,/ /);for(i in A)print A[i]}'
1090 }
1091
1092 mkc() {
1093 mkdir "$1"
1094 c "$1"
1095 }
1096 ccomp mkdir mkc
1097
1098 mkct() {
1099 mkc $(mktemp -d)
1100 }
1101
1102 mkt() { # mkdir and touch file
1103 local path="$1"
1104 mkdir -p "$(dirname "$path")"
1105 touch "$path"
1106 }
1107
1108 # shellcheck disable=SC2032
1109 mkdir() { command mkdir -p "$@"; }
1110
1111 nags() {
1112 # https://github.com/HenriWahl/Nagstamon/issues/357
1113 if ! pgrep -f /usr/lib/notification-daemon/notification-daemon >/dev/null; then
1114 /usr/lib/notification-daemon/notification-daemon &
1115 fi
1116 /usr/bin/nagstamon &
1117 }
1118
1119 nmt() {
1120 s nmtui-connect "$@"
1121 }
1122
1123 nopanic() {
1124 # shellcheck disable=SC2024
1125 sudo tee -a /var/log/exim4/paniclog-archive </var/log/exim4/paniclog; sudo truncate -s0 /var/log/exim4/paniclog
1126 }
1127
1128 p8() { ping "$@" 8.8.8.8; }
1129 p6() { ping6 "$@" 2001:4860:4860::8888; }
1130
1131 pkx() { # package extract
1132 local pkg cached tmp f
1133 c $(mktemp -d)
1134 pkg=$1
1135 # shellcheck disable=SC2012
1136 cached=$(ls -t /var/cache/apt/archives/$pkg* | tail -n1 2>/dev/null) ||:
1137 if [[ $cached ]]; then
1138 cp $cached .
1139 else
1140 aptitude download $pkg || return 1
1141 fi
1142 tmp=(*); f=${tmp[0]} # only 1 expected
1143 ex $f
1144 rm -f $f
1145 }
1146
1147 # pgrep and kill
1148 pk1() {
1149 local pid
1150 pid=($(pgrep -f "$*"))
1151 case ${#pid[@]} in
1152 1)
1153 # shellcheck disable=SC2128
1154 {
1155 ps -F $pid
1156 m kill $pid
1157 }
1158 ;;
1159 0) echo "no pid found" ;;
1160 *)
1161 ps -F ${pid[@]}
1162 ;;
1163 esac
1164 }
1165
1166 psg () {
1167 local x y help
1168 help="Usage: psg [--help] GREP_ARGS
1169 grep ps and output in a nice format"
1170 if [[ $1 == --help ]]; then
1171 echo "$help"
1172 return
1173 fi
1174 x=$(ps -eF)
1175 # final grep is because some commands tend to have a lot of trailing spaces
1176 y=$(echo "$x" | grep -iP "$@" | grep -o '.*[^ ]') ||:
1177 if [[ $y ]]; then
1178 echo "$x" | head -n 1 || [[ $? == 141 ]]
1179 echo "$y"
1180 fi
1181 }
1182
1183 pubip() { curl -4s https://icanhazip.com; }
1184 pubip6() { curl -6s https://icanhazip.com; }
1185 whatismyip() { pubip; }
1186
1187
1188 q() { # start / launch a program in the backround and redir output to null
1189 "$@" &> /dev/null &
1190 }
1191
1192 # shellcheck disable=SC2120
1193 r() {
1194 if [[ $HISTFILE ]]; then
1195 history -a # save history
1196 fi
1197 trap ERR # this avoids a segfault
1198 exit ${1:0}
1199 # i had this redir, not sure why
1200 # exit "$@" 2>/dev/null
1201 }
1202
1203 # scp is insecure and deprecated.
1204 scp() {
1205 rsync --inplace "$@"
1206 }
1207
1208 randport() {
1209 # available high ports are 1024-65535,
1210 # but lets skip things that are more likely to be in use
1211 python3 <<'EOF'
1212 import secrets
1213 print(secrets.SystemRandom().randrange(10002,65500))
1214 EOF
1215 }
1216
1217 # reapply bashrc
1218 reb() {
1219 source ~/.bashrc
1220 }
1221
1222 rl() {
1223 readlink -f "$@"
1224 }
1225 ccomp readlink rl
1226
1227 rsd() {
1228 # rsync, root is required to keep permissions right.
1229 # rsync --archive --human-readable --verbose --itemize-changes --checksum \(-ahvic\) \
1230 # --no-times --delete
1231 # basically, make an exact copy, use checksums instead of file times to be more accurate
1232 rsync -ahvic --delete "$@"
1233 }
1234 rsa() {
1235 # like rlu, but dont delete files on the target end which
1236 # do not exist on the original end.
1237 rsync -ahvic "$@"
1238 }
1239 rst() {
1240 # rl without preserving modification time.
1241 rsync -ahvic --delete --no-t "$@"
1242 }
1243 rsu() { # [OPTS] HOST PATH
1244 # eg. rlu -opts frodo /testpath
1245 # relative paths will expanded with readlink -f.
1246 opts=("${@:1:$#-2}") # 1 to last -2
1247 path="${*:$#}" # last
1248 host="${*:$#-1:1}" # last -1
1249 if [[ $path == .* ]]; then
1250 path=$(readlink -f $path)
1251 fi
1252 # rync here uses checksum instead of time so we dont mess with
1253 # unison relying on time as much. g is for group, same reason
1254 # to keep up with unison.
1255 m s rsync -rlpchviog --relative "${opts[@]}" "$path" "root@$host:/";
1256 }
1257 ccomp rsync rsd rsa rst rsu
1258
1259 resolvcat() {
1260 local f
1261 if [[ $(systemctl is-active nscd ||:) != inactive ]]; then
1262 m s nscd -i hosts
1263 fi
1264 f=/etc/resolv.conf
1265 echo $f:; ccat $f
1266 hr; s ss -lpn 'sport = 53'
1267 if systemctl is-enabled dnsmasq &>/dev/null || [[ $(systemctl is-active dnsmasq ||:) != inactive ]]; then
1268 # this will fail is dnsmasq is failed
1269 hr; m ser status dnsmasq | cat || :
1270 f=/etc/dnsmasq.conf
1271 hr; echo $f:; ccat $f
1272 hr; m grr '^ *(servers-file|server) *=|^ *no-resolv *$' /etc/dnsmasq.conf /etc/dnsmasq.d
1273 f=/etc/dnsmasq-servers.conf
1274 hr; echo $f:; ccat $f
1275 fi
1276 hr
1277 echo /etc/nsswitch.conf:
1278 grep '^ *hosts:' /etc/nsswitch.conf
1279 if systemctl is-enabled systemd-resolved &>/dev/null || [[ $(systemctl is-active systemd-resolved ||:) != inactive ]]; then
1280 hr; m ser status systemd-resolved | cat || :
1281 hr; m systemd-resolve --status | cat
1282 fi
1283
1284 }
1285 rcat() {
1286 resolvcat | less
1287 }
1288 reresolv() {
1289 if [[ $(systemctl is-active nscd ||:) != inactive ]]; then
1290 m ser stop nscd
1291 sleep .5
1292 m ser start nscd
1293 m sudo nscd -i hosts
1294 fi
1295 if [[ $(systemctl is-active dnsmasq ||:) != inactive ]]; then
1296 m sudo systemctl restart dnsmasq
1297 fi
1298 if [[ $(systemctl is-active systemd-resolved ||:) != inactive ]]; then
1299 m sudo systemctl restart systemd-resolved
1300 fi
1301 if type -P resolvectl &>/dev/null; then
1302 resolvectl flush-caches
1303 fi
1304 }
1305
1306 rmstrips() {
1307 ssh fencepost head -n 300 /gd/gnuorg/EventAndTravelInfo/rms-current-trips.txt | less
1308 }
1309
1310 s() {
1311 # background
1312 # I use a function because otherwise we cant use in a script,
1313 # cant assign to variable.
1314 #
1315 # note: gksudo is recommended for X apps because it does not set the
1316 # home directory to the same, and thus apps writing to ~ fuck things up
1317 # with root owned files.
1318 #
1319 if [[ $EUID != 0 || $1 == -* ]]; then
1320 # shellcheck disable=SC2034
1321 SUDOD="$PWD" command sudo -i "$@"
1322 DID_SUDO=true
1323 else
1324 "$@"
1325 fi
1326 }
1327 sb() { # sudo bash -c
1328 # use sb instead of s is for sudo redirections,
1329 # eg. sb 'echo "ok fine" > /etc/file'
1330 # shellcheck disable=SC2034
1331 local SUDOD="$PWD"
1332 sudo -i bash -c "$@"
1333 }
1334 ccomp sudo s sb
1335
1336 safe_rename() { # warn and dont rename if file exists.
1337 # mv -n exists, but it\'s silent
1338 if [[ $# != 2 ]]; then
1339 echo safe_rename error: $# args, need 2 >2
1340 return 1
1341 fi
1342 if [[ $1 != "$2" ]]; then # yes, we want to silently ignore this
1343 if [[ -e $2 || -L $2 ]]; then
1344 echo "Cannot rename $1 to $2 as it already exists."
1345 else
1346 mv -vi "$1" "$2"
1347 fi
1348 fi
1349 }
1350
1351
1352
1353 sd() {
1354 sudo dd status=none of="$1"
1355 }
1356
1357 ser() {
1358 if type -p systemctl &>/dev/null; then
1359 s systemctl "$@"
1360 else
1361 if (( $# >= 3 )); then
1362 echo iank: ser expected 2 or less arguments
1363 return 1
1364 fi
1365 s service $2 $1
1366 fi
1367 }
1368 seru() { systemctl --user "$@"; }
1369 # like restart, but do nothing if its not already started
1370 srestart() {
1371 local service=$1
1372 if [[ $(s systemctl --no-pager show -p ActiveState $service ) == ActiveState=active ]]; then
1373 systemctl restart $service
1374 fi
1375 }
1376
1377 setini() { # set a value in a .ini style file
1378 key="$1" value="$2" section="$3" file="$4"
1379 if [[ -s $file ]]; then
1380 sed -ri -f - "$file" <<EOF
1381 # remove existing keys
1382 / *\[$section\]/,/^ *\[[^]]+\]/{/^\s*$key[[:space:]=]/d}
1383 # add key
1384 /^\s*\[$section\]/a $key=$value
1385 # from section to eof, do nothing
1386 /^\s*\[$section\]/,\$b
1387 # on the last line, if we haven't found section yet, add section and key
1388 \$a [$section]\\
1389 $key=$value
1390 EOF
1391 else
1392 cat >"$file" <<EOF
1393 [$section]
1394 $key=$value
1395 EOF
1396 fi
1397 }
1398
1399 sgo() { # service go
1400 service=$1
1401 ser restart $service || return 1
1402 if type -p systemctl &>/dev/null; then
1403 ser enable $service
1404 fi
1405 }
1406 soff () {
1407 for service; do
1408 # ignore services that dont exist
1409 if systemctl cat $service &>/dev/null; then
1410 ser stop $service;
1411 ser disable $service
1412 fi
1413 done
1414 }
1415
1416 sgu() {
1417 systemctl list-unit-files | rg "$@"
1418 }
1419
1420
1421 sk() {
1422
1423
1424 # note, if you do something like this
1425 # x=( prefix* )
1426 # then disable the warning with:
1427 # shellcheck disable=SC2206 # globbing is intended
1428
1429 # 2029: "unescaped, this expands on the client side.": yes, I know how ssh works
1430 # 2164: "Use 'cd ... || exit' or 'cd ... || return' in case cd fails.": i have automatic error handling
1431 # 2086: unquoted $var: Quoting every var I set is way too much quotes.
1432 # 2068: Double quote array expansions to avoid re-splitting elements: same as above.
1433 # 2033: command arg is a function name: too many false positives.
1434
1435
1436 # these ones I had disabled, but without a good written explanation, so enabling them temporarily
1437 # 2046: unquoted $(cmd)
1438 # 2119: Functions with optional args get bad warnings when none are passed.
1439
1440 shellcheck -W 999 -x -e 2029,2164,2086,2068,2033 "$@" || return $?
1441 }
1442
1443
1444 # sl: ssh, but firsh rsync our bashrc and related files to a special
1445 # directory on the remote host if needed.
1446
1447 # Some environment variables and files need to be setup for this to work
1448 # (mine are set at the beginning of this file)
1449
1450 # SL_FILES_DIR: Environment variable. Path to folder which should at
1451 # least have a .bashrc file or symlink. This dir will be rsynced to ~ on
1452 # remote hosts (top level symlinks are resolved) unless the host already
1453 # has a $SL_FILES_DIR/.bashrc. In that case, we assume it is a host you
1454 # control and sync files to separately and already has the ~/.bashrc you
1455 # want. The remote bash will also take its .inputrc config from this
1456 # folder (default of not existing is fine). Mine looks like this:
1457 # https://iankelling.org/git/?p=distro-setup;a=tree;f=sl/.iank
1458
1459 # SL_INFO_DIR: Environment variable. This folder stores info about what
1460 # we detected on the remote system and when we last synced. It will be created
1461 # if it does not exist. Sometimes you may want to forget about a
1462 # remote system, you can use sl --rsync, or the function for that slr
1463 # below.
1464
1465 # SL_TEST_CMD: Env var. Meant to be used to vary the files synced
1466 # depending on the remote host. Run this string on the remote host the
1467 # first time sl is run (or if we run slr). The result is passed to
1468 # SL_TEST_HOOK. For example,
1469 # export SL_TEST_CMD=". /etc/os-release ; echo \${VERSION//[^a-zA-Z0-9]/}"
1470
1471 # SL_TEST_HOOK: Env var. It is run as $SL_TEST_HOOK. This can set
1472 # $SL_FILES_DIR to vary the files synced.
1473
1474 # SL_RSYNC_ARGS: Env var. String of arguments passed to rsync. For
1475 # example to exclude files within a directory. Note, excluded
1476 # files wont be deleted on rsync, you can add --delete-excluded
1477 # to the rsync command if that is desired.
1478
1479 # SL_SSH_ARGS: Env var. Default arguments passed to ssh.
1480
1481 # For when ~/.bashrc is already customized on the remote server, you
1482 # might find it problematic that ~/.bashrc is sourced for ALL ssh
1483 # commands, even in scripts. This paragraph is all about that. bash
1484 # scripts dont source ~/.bashrc, but call ssh in scripts and you get
1485 # ~/.bashrc. You dont want this. .bashrc is meant for interactive shells
1486 # and if you customize it, probably has bugs from time to time. This is
1487 # bad. Here's how I fix it. I have a special condition to "return" in my
1488 # .bashrc for noninteractive ssh shells (copy that code). Then use this
1489 # function or similar that passes LC_USEBASHRC=t when sshing and I want
1490 # my bashrc. Also, I don't keep most of my bashrc in .bashrc, i source a
1491 # separate file because even if I return early on, the whole file gets
1492 # parsed which can fail if there is a syntax error.
1493 sl() {
1494 # Background on LC_USEBASHRC var (no need to read if you just want to
1495 # use this function): env variables sent across ssh are strictly
1496 # limited, but we get LC_* at least in debian based machines, so we
1497 # just make that * be something no normal program would use. Note, on
1498 # hosts that dont allow LC_* I start an inner shell with LC_USEBASHRC
1499 # set, and the inner shell also allows running a nondefault
1500 # .bashrc. This means the outer shell still ran the default .bashrc,
1501 # but that is the best we can do.
1502
1503 local now args remote dorsync haveinfo tmpa sshinfo tmp tmp2 type info_sec force_rsync \
1504 sync_dirname testcmd extra_info testbool files_sec sl_test_cmd sl_test_hook
1505 declare -a args tmpa
1506
1507 args=($SL_SSH_ARGS)
1508
1509 # ssh [-1246Antivivisectionist] [-b bind_address] [-c cipher_spec] [-D [bind_address:]port]
1510 # [-E log_file] [-e escape_char] [-F configfile] [-I pkcs11] [-i identity_file] [-L address]
1511 # [-l login_name] [-m mac_spec] [-O ctl_cmd] [-o option] [-p port] [-Q query_option]
1512 # [-R address] [-S ctl_path] [-W host:port] [-w local_tun[:remote_tun]] [user@]hostname
1513 # [command]
1514
1515 # ssh [-46AaCfGgKkMNnqsTtVvXxYy] [-b bind_address] [-c cipher_spec]
1516 # [-D [bind_address:]port] [-E log_file] [-e escape_char]
1517 # [-F configfile] [-I pkcs11] [-i identity_file]
1518 # [-J [user@]host[:port]] [-L address] [-l login_name] [-m mac_spec]
1519 # [-O ctl_cmd] [-o option] [-p port] [-Q query_option] [-R address]
1520 # [-S ctl_path] [-W host:port] [-w local_tun[:remote_tun]]
1521
1522 force_rsync=false
1523 if [[ $1 == --rsync ]]; then
1524 force_rsync=true
1525 shift
1526 fi
1527
1528 sl_test_cmd=$SL_TEST_CMD
1529 sl_test_hook=$SL_TEST_HOOK
1530 sl_rsync_args=$SL_RSYNC_ARGS
1531 while [[ $1 ]]; do
1532 case "$1" in
1533 --rsync)
1534 force_rsync=true
1535 ;;
1536 --sl-test-cmd)
1537 sl_test_cmd="$2"
1538 shift
1539 ;;
1540 --sl-test-hook)
1541 sl_test_hook="$2"
1542 shift
1543 ;;
1544 --sl-rsync-args)
1545 sl_rsync_args="$2"
1546 shift
1547 ;;
1548 *)
1549 break
1550 ;;
1551 esac
1552 shift
1553 done
1554
1555 while [[ $1 ]]; do
1556 case "$1" in
1557 # note we dont support things like -4oOption
1558 -[46AaCfGgKkMNnqsTtVvXxYy]*)
1559 args+=("$1"); shift
1560 ;;
1561 -[bcDEeFIiJLlmOopQRSWw]*)
1562 # -oOption etc is valid
1563 if (( ${#1} >= 3 )); then
1564 args+=("$1"); shift
1565 else
1566 args+=("$1" "$2"); shift 2
1567 fi
1568 ;;
1569 *)
1570 break
1571 ;;
1572 esac
1573 done
1574 remote="$1"
1575 if [[ ! $remote ]]; then
1576 echo $0: error hostname required >&2
1577 return 1
1578 fi
1579 shift
1580
1581 if [[ ! $SL_INFO_DIR ]]; then
1582 echo error: missing '$SL_INFO_DIR' env var >&2
1583 return 1
1584 fi
1585
1586 now=$(date +%s)
1587 dorsync=false
1588 haveinfo=false
1589 tmpa=($SL_INFO_DIR/???????????"$remote")
1590 sshinfo=${tmpa[0]}
1591 if [[ -e $sshinfo ]]; then
1592 if $force_rsync; then
1593 rm -f $sshinfo
1594 else
1595 haveinfo=true
1596 fi
1597 fi
1598 if $haveinfo; then
1599 tmp=${sshinfo[0]##*/}
1600 tmp2=${tmp::11}
1601 type=${tmp2: -1}
1602 extra_info=$(cat $sshinfo)
1603 else
1604 # we test for string to know ssh succeeded
1605 testbool="test -e $SL_FILES_DIR/.bashrc -a -L .bashrc -a -v LC_USEBASHRC"
1606 testcmd="if $testbool; then printf y; else printf n; fi"
1607 if ! tmp=$(LC_USEBASHRC=y command ssh "${args[@]}" "$remote" "$testcmd; $sl_test_cmd"); then
1608 echo failed sl test. doing plain ssh -v
1609 command ssh -v "${args[@]}" "$remote"
1610 fi
1611 if [[ $tmp == y* ]]; then
1612 type=a
1613 else
1614 dorsync=true
1615 type=b
1616 fi
1617 extra_info="${tmp:1}"
1618 fi
1619 if [[ $sl_test_hook ]]; then
1620 RSYNC_RSH="ssh ${args[*]}" $sl_test_hook "$extra_info" "$remote"
1621 fi
1622
1623 if $haveinfo && [[ $type == b ]]; then
1624 info_sec=${tmp::10}
1625 read files_sec _ < <(find -L $SL_FILES_DIR -printf "%T@ %p\n" | sort -nr || [[ $? == 141 || ${PIPESTATUS[0]} == 32 ]] )
1626 files_sec=${files_sec%%.*}
1627 if (( files_sec > info_sec )); then
1628 dorsync=true
1629 rm -f $sshinfo
1630 fi
1631 fi
1632
1633 sync_dirname=${SL_FILES_DIR##*/}
1634
1635 if [[ ! $SL_FILES_DIR ]]; then
1636 echo error: missing '$SL_FILES_DIR' env var >&2
1637 return 1
1638 fi
1639
1640 if $dorsync; then
1641 RSYNC_RSH="ssh ${args[*]}" m rsync -rptL --delete $sl_rsync_args $SL_FILES_DIR "$remote":
1642 fi
1643 if $dorsync || ! $haveinfo; then
1644 sshinfo=$SL_INFO_DIR/$now$type"$remote"
1645 [[ -e $SL_INFO_DIR ]] || mkdir -p $SL_INFO_DIR
1646 printf "%s\n" "$extra_info" >$sshinfo
1647 chmod 666 $sshinfo
1648 fi
1649 if [[ $type == b ]]; then
1650 if (( ${#@} )); then
1651 # Theres a couple ways to pass arguments, im not sure whats best,
1652 # but relying on bash 4.4+ escape quoting seems most reliable.
1653 command ssh "${args[@]}" "$remote" \
1654 LC_USEBASHRC=t bash -c '.\ '$sync_dirname'/.bashrc\;"\"\$@\""' bash ${@@Q}
1655 elif [[ ! -t 0 ]]; then
1656 # This case is when commands are being piped to ssh.
1657 # Normally, no bashrc gets sourced.
1658 # But, since we are doing all this, lets source it because we can.
1659 cat <(echo . $sync_dirname/.bashrc) - | command ssh "${args[@]}" "$remote" LC_USEBASHRC=t bash
1660 else
1661 command ssh -t "${args[@]}" "$remote" LC_USEBASHRC=t INPUTRC=$sync_dirname/.inputrc bash --rcfile $sync_dirname/.bashrc
1662 fi
1663 else
1664 if [[ -t 0 ]]; then
1665 LC_USEBASHRC=t command ssh "${args[@]}" "$remote" ${@@Q}
1666 else
1667 command ssh "${args[@]}" "$remote" LC_USEBASHRC=t bash
1668 fi
1669 fi
1670 # this function inspired from https://github.com/Russell91/sshrc
1671 }
1672
1673 slr() {
1674 sl --rsync "$@"
1675 }
1676 sss() { # ssh solo
1677 sl -oControlMaster=no -oControlPath=/ "$@"
1678 }
1679 # kill off old shared socket then ssh
1680 ssk() {
1681 m ssh -O exit "$@" || [[ $? == 255 ]]
1682 m sl "$@"
1683 }
1684 ccomp ssh sl slr sss ssk
1685 # plain ssh
1686 ssh() {
1687 if [[ $TERM == alacritty || $TERM == xterm-kitty ]]; then
1688 TERM=xterm-256color LC_USEBASHRC=t command ssh "$@"
1689 else
1690 LC_USEBASHRC=t command ssh "$@"
1691 fi
1692 }
1693
1694
1695 slog() {
1696 # log with script. timing is $1.t and script is $1.s
1697 # -l to save to ~/typescripts/
1698 # -t to add a timestamp to the filenames
1699 local logdir do_stamp arg_base
1700 (( $# >= 1 )) || { echo "arguments wrong"; return 1; }
1701 logdir="/a/dt/"
1702 do_stamp=false
1703 while getopts "lt" option
1704 do
1705 case $option in
1706 l ) arg_base=$logdir ;;
1707 t ) do_stamp=true ;;
1708 esac
1709 done
1710 shift $((OPTIND - 1))
1711 arg_base+=$1
1712 [[ -e $logdir ]] || mkdir -p $logdir
1713 $do_stamp && arg_base+=$(date +%F.%T%z)
1714 script -t $arg_base.s 2> $arg_base.t
1715 }
1716 splay() { # script replay
1717 #logRoot="$HOME/typescripts/"
1718 #scriptreplay "$logRoot$1.t" "$logRoot$1.s"
1719 scriptreplay "$1.t" "$1.s"
1720 }
1721
1722 sr() {
1723 # sudo redo. be aware, this command may not work right on strange distros or earlier software
1724 if [[ $# == 0 ]]; then
1725 sudo -E bash -c -l "$(history -p '!!')"
1726 else
1727 echo this command redos last history item. no argument is accepted
1728 fi
1729 }
1730
1731 srm () {
1732 # with -ll, less secure but faster.
1733 command srm -ll "$@"
1734 }
1735
1736 srun() {
1737 scp $2 $1:/tmp
1738 ssh $1 /tmp/${2##*/} $(printf "%q\n" "${@:2}")
1739 }
1740
1741
1742 swap() {
1743 local tmp
1744 tmp=$(mktemp)
1745 mv $1 $tmp
1746 mv $2 $1
1747 mv $tmp $2
1748 }
1749
1750 tclock() { # terminal clock
1751 local x
1752 clear
1753 date +%l:%_M
1754 len=60
1755 # this goes to full width
1756 #len=${1:-$((COLUMNS -7))}
1757 x=1
1758 while true; do
1759 if (( x == len )); then
1760 end=true
1761 d="$(date +%l:%_M) "
1762 else
1763 end=false
1764 d=$(date +%l:%M:%_S)
1765 fi
1766 echo -en "\r"
1767 echo -n "$d"
1768 for ((i=0; i<x; i++)); do
1769 if (( i % 6 )); then
1770 echo -n _
1771 else
1772 echo -n .
1773 fi
1774 done
1775 if $end; then
1776 echo
1777 x=1
1778 else
1779 x=$((x+1))
1780 fi
1781 sleep 5
1782 done
1783 }
1784
1785
1786 te() {
1787 # test existence / exists
1788 local ret=0
1789 for x in "$@"; do
1790 [[ -e "$x" || -L "$x" ]] || ret=1
1791 done
1792 return $ret
1793 }
1794
1795 psoff() {
1796 # normally, i would just execute these commands in the function.
1797 # however, DEBUG is not inherited, so we need to run it outside a function.
1798 # And we want to run set -x afterwards to avoid spam, so we cram everything
1799 # in here, and then it will run after this function is done.
1800 PROMPT_COMMAND='trap DEBUG; unset PROMPT_COMMAND; PS1="\w \$ "'
1801 }
1802 pson() {
1803 PROMPT_COMMAND=prompt-command
1804 if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
1805 trap 'settitle "$BASH_COMMAND"' DEBUG
1806 fi
1807 }
1808
1809 tx() { # toggle set -x, and the prompt so it doesnt spam
1810 if [[ $- == *x* ]]; then
1811 set +x
1812 pson
1813 else
1814 psoff
1815 fi
1816 }
1817
1818 psnetns() {
1819 # show all processes in the network namespace $1.
1820 # blank entries appear to be subprocesses/threads
1821 local x netns
1822 netns=$1
1823 ps -w | head -n 1
1824 sudo find -L /proc/[1-9]*/task/*/ns/net -samefile /run/netns/$netns | cut -d/ -f5 | \
1825 while read -r l; do
1826 x=$(ps -w --no-headers -p $l);
1827 if [[ $x ]]; then echo "$x"; else echo $l; fi;
1828 done
1829 }
1830
1831 m() { printf "%s\n" "$*"; "$@"; }
1832
1833 uptime() {
1834 if type -p uprecords &>/dev/null; then
1835 uprecords -B
1836 else
1837 command uptime
1838 fi
1839 }
1840
1841 virshrm() {
1842 for x in "$@"; do virsh destroy "$x"; virsh undefine "$x"; done
1843 }
1844
1845 vm-set-listen(){
1846 local t
1847 t=$(mktemp)
1848 local vm=$1
1849 local ip=$2
1850 sudo virsh dumpxml $vm | sed -r "s/(<listen.*address=')([^']+)/\1$ip/" | \
1851 sed -r "s/listen='[^']+/listen='$ip/"> $t
1852 sudo virsh undefine $vm
1853 sudo virsh define $t
1854 }
1855
1856
1857 vmshare() {
1858 vm-set-listen $1 0.0.0.0
1859 }
1860
1861
1862 vmunshare() {
1863 vm-set-listen $1 127.0.0.1
1864 }
1865
1866 myiwscan() {
1867 # find input, copy to pattern space, when we find the first field, print the copy in different order without newlines.
1868 # instead of using labels, we could just match a line and group, eg: /signal:/,{s/signal:(.*)/\1/h}
1869 sudo iw dev wls1 scan | sed -rn "
1870 s/^\Wcapability: (.*)/\1/;Ta;h;b
1871 :a;s/^\Wsignal: -([^.]+).*/\1/;Tb;H;b
1872 # padded to min width of 20
1873 :b;s/\WSSID: (.*)/\1 /;T;s/^(.{20}(.*[^ ])?) */\1/;H;g;s/(.*)\n(.*)\n(.*)/\2 \3 \1/gp;b
1874 "|sort -r
1875 }
1876
1877 # * misc stuff
1878
1879
1880 # temporary variables to test colorization
1881 # some copied from gentoo /etc/bash/bashrc,
1882 use_color=false
1883 # dircolors --print-database uses its own built-in database
1884 # instead of using /etc/DIR_COLORS. Try to use the external file
1885 # first to take advantage of user additions.
1886 safe_term=${TERM//[^[:alnum:]]/?} # sanitize TERM
1887 match_lhs=""
1888 [[ -f ~/.dir_colors ]] && match_lhs="${match_lhs}$(<~/.dir_colors)"
1889 [[ -f /etc/DIR_COLORS ]] && match_lhs="${match_lhs}$(</etc/DIR_COLORS)"
1890 [[ -z ${match_lhs} ]] \
1891 && type -P dircolors >/dev/null \
1892 && match_lhs=$(dircolors --print-database)
1893 # test if our $TERM is in the TERM values in dircolor
1894 [[ $'\n'${match_lhs} == *$'\n'"TERM "${safe_term}* ]] && use_color=true
1895
1896
1897 if ${use_color} && [[ $- == *i* ]]; then
1898
1899 term_bold="$(tput bold)"
1900 term_red="$(tput setaf 1)"
1901 term_green="$(tput setaf 2)"
1902 term_yellow="$(tput setaf 3)"
1903 term_purple="$(tput setaf 5)"
1904 term_nocolor="$(tput sgr0)" # no font attributes
1905
1906 # unused so far. commented for shellcheck
1907 # term_underl="$(tput smul)"
1908 # term_blue="$(tput setaf 4)"
1909 # term_cyan="$(tput setaf 6)"
1910
1911 fi
1912 # Try to keep environment pollution down, EPA loves us.
1913 unset safe_term match_lhs use_color
1914
1915 # * prompt
1916
1917
1918 if [[ $- == *i* ]]; then
1919
1920 # this needs to come before next ps1 stuff
1921 # this stuff needs bash 4, feb 2009,
1922 # old enough to no longer condition on $BASH_VERSION anymore
1923 shopt -s autocd
1924 shopt -s dirspell
1925 PS1='\w'
1926 if [[ $- == *i* ]] && [[ ! $LC_INSIDE_EMACS ]]; then
1927 PROMPT_DIRTRIM=2
1928 bind -m vi-command B:shell-backward-word
1929 bind -m vi-command W:shell-forward-word
1930 fi
1931
1932 if [[ $SSH_CLIENT || $SUDO_USER ]]; then
1933 unset PROMPT_DIRTRIM
1934 PS1="\h:$PS1"
1935 fi
1936
1937 # emacs terminal has problems if this runs slowly,
1938 # so I've thrown a bunch of things at the wall to speed it up.
1939 prompt-command() {
1940 local return=$? # this MUST COME FIRST
1941 local ps_char ps_color
1942 unset IFS
1943
1944 if [[ $HISTFILE ]]; then
1945 history -a # save history
1946 fi
1947
1948 # assigned in brc2
1949 # shellcheck disable=SC1303
1950 if [[ $jr_pid ]]; then
1951 if [[ -e /proc/$jr_pid ]]; then
1952 kill $jr_pid
1953 fi
1954 unset jr_pid
1955 fi
1956
1957 case $return in
1958 0) ps_color="$term_purple"
1959 ps_char='\$'
1960 ;;
1961 1) ps_color="$term_green"
1962 ps_char="$return \\$"
1963 ;;
1964 *) ps_color="$term_yellow"
1965 ps_char="$return \\$"
1966 ;;
1967 esac
1968 if [[ ! -O . ]]; then # not owner
1969 if [[ -w . ]]; then # writable
1970 ps_color="$term_bold$term_red"
1971 else
1972 ps_color="$term_bold$term_green"
1973 fi
1974 fi
1975
1976 # faster than sourceing the file im guessing
1977 if [[ -e /dev/shm/iank-status && ! -e /tmp/quiet-status ]]; then
1978 eval $(< /dev/shm/iank-status)
1979 fi
1980 if [[ ! $SSH_CLIENT && $MAIL_HOST != "$HOSTNAME" ]]; then
1981 ps_char="@ $ps_char"
1982 fi
1983 # We could test if sudo is active with sudo -nv
1984 # but then we get an email and log of lots of failed sudo commands.
1985 # We could turn those off, but seems better not to.
1986 if [[ $EUID != 0 ]] && [[ $DID_SUDO ]]; then
1987 ps_char="SUDO $ps_char"
1988 fi
1989 if [[ ! $HISTFILE ]]; then
1990 ps_char="NOHIST $ps_char"
1991 fi
1992 PS1="${PS1%"${PS1#*[wW]}"} \[$ps_color\]$ps_char\[$term_nocolor\] "
1993
1994 # set titlebar. instead, using more advanced
1995 # titelbar below
1996 #echo -ne "$_title_escape $HOSTNAME ${PWD/#$HOME/~} \007"
1997 }
1998 PROMPT_COMMAND=prompt-command
1999
2000 if [[ $TERM == screen* ]]; then
2001 _title_escape="\033]..2;"
2002 else
2003 # somme sites recommend this, i dunno what the diff is.
2004 #_title_escape="\033]30;"
2005 _title_escape="\033]0;"
2006 fi
2007
2008 settitle () {
2009 # this makes it so we show the current command if
2010 # one is running, otherwise, show nothing
2011
2012 if [[ $1 == prompt-command ]]; then
2013 return 0
2014 fi
2015 if (( ${#BASH_ARGC[@]} == 1 && BASH_SUBSHELL == 0 )); then
2016 echo -ne "$_title_escape ${PWD/#$HOME/~} "
2017 printf "%s" "$*"
2018 echo -ne "\007"
2019 fi
2020 }
2021
2022 # note, this wont work:
2023 # x=$(mktemp); cp a $x
2024 # I havnt figured out why, bigger fish to fry.
2025 #
2026 # for titlebar.
2027 # condition from the screen man page i think.
2028 # note: duplicated in tx()
2029 if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
2030 trap 'settitle "$BASH_COMMAND"' DEBUG
2031 else
2032 trap DEBUG
2033 fi
2034
2035 fi
2036
2037 # * stuff that makes sense to be at the end
2038
2039
2040 # best practice
2041 unset IFS
2042
2043 # shellcheck disable=SC1090
2044 [[ -s "$HOME/.rvm/scripts/rvm" ]] && source "$HOME/.rvm/scripts/rvm" # Load RVM into a shell session *as a function*
2045
2046 # I had this idea to start a bash shell which would run an initial
2047 # command passed through this env variable, then continue on
2048 # interactively. But the use case I had in mind went away.
2049 #
2050 # if [[ $MY_INIT_CMD ]]; then
2051 # "${MY_INIT_CMD[@]}"
2052 # unset MY_INIT_CMD
2053 # fi
2054
2055 # ensure no bad programs appending to this file will have an affect
2056 return 0